class KFind

# class KFind | A generic implementation of the "find" function. More...
Definition | `#include <kfind.h>`
Inherits | QObject (qt) [public ]
Inherited by | KReplace
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum Result { NoMatch, Match }

#### Public Methods

- KFind (const QString &pattern, long options, QWidget *parent)
- virtual ~KFind ()
- bool needData () const
- void setData ( const QString& data, int startPos = -1 )
- Result find ()
- long options () const
- virtual void setOptions ( long options )
- int numMatches () const
- virtual void resetCounts ()
- virtual bool validateMatch ( const QString &, int , int )
- virtual bool shouldRestart ( bool forceAsking = false, bool showNumMatches = true ) const
- virtual void displayFinalDialog () const
- KDialogBase* findNextDialog ( bool create = false )
- void closeFindNextDialog ()

#### Signals

- void highlight (const QString &text, int matchingIndex, int matchedLength)
- void findNext ()
- void optionsChanged ()
- void dialogClosed ()

#### Public Static Methods

- static int find ( const QString &text, const QString &pattern, int index, long options, int *matchedlength )
- static int find ( const QString &text, const QRegExp &pattern, int index, long options, int *matchedlength )

#### Protected Methods

- KFind (const QString &pattern, const QString &replacement, long options, QWidget *parent)
- QWidget* parentWidget () const

#### Protected Slots

- void slotFindNext ()
- void slotDialogClosed ()

## Detailed Description

### Detail

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behaviour instead of using the class directly.

### Example

To use the class to implement a complete find feature:

In the slot connected to the find action, after using KFindDialog:

      // This creates a find-next-prompt dialog if needed.
      m_find = new KFind(pattern, options);

      // Connect highlight signal to code which handles highlighting
      // of found text.
      connect( m_find, SIGNAL( highlight( const QString &, int, int ) ),
              this, SLOT( slotHighlight( const QString &, int, int ) ) );
      // Connect findNext signal - called when pressing the button in the dialog
      connect( m_find, SIGNAL( findNext() ),
              this, SLOT( slotFindNext() ) );

Then initialize the variables determining the "current position" (to the cursor, if the option FromCursor is set, to the beginning of the selection if the option SelectedText is set, and to the beginning of the document otherwise). Initialize the "end of search" variables as well (end of doc or end of selection). Swap begin and end if FindBackwards. Finally, call slotFindNext();

      void slotFindNext()
      {
          KFind::Result res = KFind::NoMatch;
          while ( res == KFind::NoMatch &&  ) {
              if ( m_find->needData() )
                  m_find->setData(  );

              // Let KFind inspect the text fragment, and display a dialog if a match is found
              res = m_find->find();

              if ( res == KFind::NoMatch ) {

              }
          }

          if ( res == KFind::NoMatch ) // i.e. at end
              displayFinalDialog(); delete m_find; m_find = 0L;
               or           if ( m_find->shouldRestart() ) { reinit and call slotFindNext(); }
                            else { delete m_find; m_find = 0L; }>
      }

Don't forget delete m_find in the destructor of your class, unless you gave it a parent widget on construction.

This implementation allows to have a "Find Next" action, which resumes the search, even if the user closed the "Find Next" dialog.

A "Find Previous" action can simply switch temporarily the value of FindBackwards and call slotFindNext() - and reset the value afterwards.

KFind (const QString &pattern, long options, QWidget *parent) | ### KFind

~KFind () | ### ~KFind

[virtual]

enum Result { NoMatch, Match } | ### Result

bool needData () | ### needData

[const]

Returns: true if the application must supply a new text fragment It also means the last call returned "NoMatch". But by storing this here the application doesn't have to store it in a member variable (between calls to slotFindNext()).

void setData ( const QString& data, int startPos = -1 ) | ### setData

Call this when needData returns true, before calling find().

Parameters:

data | the text fragment (line)
startPos | if set, the index at which the search should start. This is only necessary for the very first call to setData usually, for the 'find in selection' feature. A value of -1 (the default value) means "process all the data", i.e. either 0 or data.length()-1 depending on FindBackwards.

Result find () | ### find

Walk the text fragment (e.g. text-processor line, kspread cell) looking for matches. For each match, emits the highlight() signal and displays the find-again dialog proceeding.

long options () | ### options

[const]

Return the current options.

Warning: this is usually the same value as the one passed to the constructor, but options might change _during_ the replace operation: e.g. the "All" button resets the PromptOnReplace flag.

void setOptions ( long options ) | ### setOptions

[virtual]

Set new options. Usually this is used for setting or clearing the FindBackwards options.

int numMatches () | ### numMatches

[const]

Return the number of matches found (i.e. the number of times the highlight signal was emitted). If 0, can be used in a dialog box to tell the user "no match was found". The final dialog does so already, unless you used setDisplayFinalDialog(false).

void resetCounts () | ### resetCounts

[virtual]

Call this to reset the numMatches count (and the numReplacements count for a KReplace). Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document.

bool validateMatch ( const QString &, int , int ) | ### validateMatch

[virtual]

Virtual method, which allows applications to add extra checks for validating a candidate match. It's only necessary to reimplement this if the find dialog extension has been used to provide additional criterias.

Parameters:

text | The current text fragment
index | The starting index where the candidate match was found
matchedlength | The length of the candidate match

bool shouldRestart ( bool forceAsking = false, bool showNumMatches = true ) | ### shouldRestart

[const virtual]

Returns true if we should restart the search from scratch. Can ask the user, or return false (if we already searched the whole document).

Parameters:

forceAsking | set to true if the user modified the document during the search. In that case it makes sense to restart the search again.
showNumMatches | set to true if the dialog should show the number of matches. Set to false if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).

int find ( const QString &text, const QString &pattern, int index, long options, int *matchedlength ) | ### find

[static]

Search the given string, and returns whether a match was found. If one is, the length of the string matched is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters:

text | The string to search.
pattern | The pattern to look for.
index | The starting index into the string.
options | . The options to use.

Returns: The index at which a match was found, or -1 if no match was found.

int find ( const QString &text, const QRegExp &pattern, int index, long options, int *matchedlength ) | ### find

[static]

void displayFinalDialog () | ### displayFinalDialog

[const virtual]

Displays the final dialog saying "no match was found", if that was the case. Call either this or shouldRestart().

KDialogBase* findNextDialog ( bool create = false ) | ### findNextDialog

Return (or create) the dialog that shows the "find next?" prompt. Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog.

void closeFindNextDialog () | ### closeFindNextDialog

Close the "find next?" dialog. The application should do this when the last match was hit. If the application deletes the KFind, then "find previous" won't be possible anymore.

void highlight (const QString &text, int matchingIndex, int matchedLength) | ### highlight

[signal]

Connect to this signal to implement highlighting of found text during the find operation.

void findNext () | ### findNext

[signal]

void optionsChanged () | ### optionsChanged

[signal]

Emitted when the options have changed. This can happen e.g. with "Replace All", or if our 'find next' dialog gets a "find previous" one day.

void dialogClosed () | ### dialogClosed

[signal]

Emitted when the 'find next' dialog is being closed. Some apps might want to remove the highlighted text when this happens. Apps without support for "Find Next" can also do m_find->deleteLater() to terminate the find operation.

KFind (const QString &pattern, const QString &replacement, long options, QWidget *parent) | ### KFind

[protected]

QWidget* parentWidget () | ### parentWidget

[protected const]

void slotFindNext () | ### slotFindNext

[protected slots slot]

void slotDialogClosed () | ### slotDialogClosed

[protected slots slot]

- Author: S.R.Haque , David Faure
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:38:16 2003, using kdoc 2.0a54.